// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from radar_msgs:msg/RadarScan.idl
// generated code does not contain a copyright notice
#include "radar_msgs/msg/detail/radar_scan__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `returns`
#include "radar_msgs/msg/detail/radar_return__functions.h"

bool
radar_msgs__msg__RadarScan__init(radar_msgs__msg__RadarScan * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    radar_msgs__msg__RadarScan__fini(msg);
    return false;
  }
  // returns
  if (!radar_msgs__msg__RadarReturn__Sequence__init(&msg->returns, 0)) {
    radar_msgs__msg__RadarScan__fini(msg);
    return false;
  }
  return true;
}

void
radar_msgs__msg__RadarScan__fini(radar_msgs__msg__RadarScan * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // returns
  radar_msgs__msg__RadarReturn__Sequence__fini(&msg->returns);
}

radar_msgs__msg__RadarScan *
radar_msgs__msg__RadarScan__create()
{
  radar_msgs__msg__RadarScan * msg = (radar_msgs__msg__RadarScan *)malloc(sizeof(radar_msgs__msg__RadarScan));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(radar_msgs__msg__RadarScan));
  bool success = radar_msgs__msg__RadarScan__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
radar_msgs__msg__RadarScan__destroy(radar_msgs__msg__RadarScan * msg)
{
  if (msg) {
    radar_msgs__msg__RadarScan__fini(msg);
  }
  free(msg);
}


bool
radar_msgs__msg__RadarScan__Sequence__init(radar_msgs__msg__RadarScan__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  radar_msgs__msg__RadarScan * data = NULL;
  if (size) {
    data = (radar_msgs__msg__RadarScan *)calloc(size, sizeof(radar_msgs__msg__RadarScan));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = radar_msgs__msg__RadarScan__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        radar_msgs__msg__RadarScan__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
radar_msgs__msg__RadarScan__Sequence__fini(radar_msgs__msg__RadarScan__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      radar_msgs__msg__RadarScan__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

radar_msgs__msg__RadarScan__Sequence *
radar_msgs__msg__RadarScan__Sequence__create(size_t size)
{
  radar_msgs__msg__RadarScan__Sequence * array = (radar_msgs__msg__RadarScan__Sequence *)malloc(sizeof(radar_msgs__msg__RadarScan__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = radar_msgs__msg__RadarScan__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
radar_msgs__msg__RadarScan__Sequence__destroy(radar_msgs__msg__RadarScan__Sequence * array)
{
  if (array) {
    radar_msgs__msg__RadarScan__Sequence__fini(array);
  }
  free(array);
}
