// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from radar_msgs:msg/RadarTrack.idl
// generated code does not contain a copyright notice

#ifndef RADAR_MSGS__MSG__DETAIL__RADAR_TRACK__STRUCT_H_
#define RADAR_MSGS__MSG__DETAIL__RADAR_TRACK__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'NO_CLASSIFICATION'.
enum
{
  radar_msgs__msg__RadarTrack__NO_CLASSIFICATION = 0
};

/// Constant 'STATIC'.
enum
{
  radar_msgs__msg__RadarTrack__STATIC = 1
};

/// Constant 'DYNAMIC'.
enum
{
  radar_msgs__msg__RadarTrack__DYNAMIC = 2
};

// Include directives for member types
// Member 'uuid'
#include "unique_identifier_msgs/msg/detail/uuid__struct.h"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.h"
// Member 'velocity'
// Member 'acceleration'
// Member 'size'
#include "geometry_msgs/msg/detail/vector3__struct.h"

// Struct defined in msg/RadarTrack in the package radar_msgs.
typedef struct radar_msgs__msg__RadarTrack
{
  unique_identifier_msgs__msg__UUID uuid;
  geometry_msgs__msg__Point position;
  geometry_msgs__msg__Vector3 velocity;
  geometry_msgs__msg__Vector3 acceleration;
  geometry_msgs__msg__Vector3 size;
  uint16_t classification;
  float position_covariance[6];
  float velocity_covariance[6];
  float acceleration_covariance[6];
  float size_covariance[6];
} radar_msgs__msg__RadarTrack;

// Struct for a sequence of radar_msgs__msg__RadarTrack.
typedef struct radar_msgs__msg__RadarTrack__Sequence
{
  radar_msgs__msg__RadarTrack * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} radar_msgs__msg__RadarTrack__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RADAR_MSGS__MSG__DETAIL__RADAR_TRACK__STRUCT_H_
